(in-package #:odo/test)

(defun test-state-space (ss)
  (let ((x (odo:make-variable 'integer :name 'x))
        (x2 (odo:make-variable 'integer :name 'x))
        (y (odo:make-variable-vector 4 'real :name 'y))
        (y2 (odo:make-variable-vector 3 'real :name 'y2 :uncontrollable-p t))
        (out-assigned (odo:make-variable 'integer :name :out :min 1 :max 1))
        (r (odo:make-variable 'real :name :r :min 5d0 :max 5d0)))

    (odo:state-space-add! ss x)
    (is (eql x (odo:state-space-get ss 'x)))
    (signals odo:state-space-error (odo:state-space-add! ss x2))
    (signals odo:state-space-error (odo:state-space-get ss 'y))
    (is (eql 'unknown (odo:state-space-get ss 'y nil 'unknown)))
    (odo:state-space-add! ss y)
    (dotimes (i 4)
      (is (eql (aref y i) (odo:state-space-get ss `(y ,i)))))
    (let ((vars (odo:state-space-list ss)))
      (is (member x vars))
      (dotimes (i 4)
        (is (member (aref y i) vars)))
      (is (= 5 (length vars))))
    (signals odo:state-space-error (odo:state-space-add! ss 5))
    (finishes (odo:state-space-add! ss (list x)))

    (odo:state-space-add! ss y)
    (finishes (odo:state-space-add! ss y))
    (odo:state-space-add! ss y2)
    (finishes (odo:state-space-add! ss y2))

    (odo:state-space-add! ss out-assigned)
    (odo:state-space-add! ss r)
    (is (alex:set-equal
         (odo:externalize-state-space ss :alist :assigned-p t)
         `((:out . (1))
           (:r . (5d0)))
         :test #'equal))
    (signals odo:domain-error
      (odo:externalize-state-space ss :alist))
    (is (not (odo:state-space-assigned-p ss)))

    (setf (odo:annotation x :test-annot) t)
    (is-true (odo:annotation x :test-annot))
    (when (odo:state-space-p ss)
      (let ((copied-ss (odo:copy ss)))
        (is (odo:equal-p ss copied-ss))
        (is (not (eql ss copied-ss)))))))

(defun test-state-space-implementation (fun)
  (let ((ss (funcall fun))
        (*print-right-margin* most-positive-fixnum))
    (test-state-space ss)
    (is (odo:state-space-p ss))
    (uiop:with-temporary-file (:pathname pn :keep nil)
      (odo:write-state-space-to-file ss pn :if-exists :supersede)
      (is (string-equal
           (alex:read-file-into-string (asdf:system-relative-pathname
                                        :odo
                                        "test/model-api/state-space-files/1.sexp"))
           (alex:read-file-into-string pn))))))

(defun test-state-space-assigned-p (fun)
  (let ((ss (funcall fun)))
    (let ((x (odo:make-variable 'integer :name 'x :min 5 :max 5))
          (y (odo:make-variable-vector 4 'real :name 'y))
          (y2 (odo:make-variable-vector 3 'real :name 'y2 :uncontrollable-p t))
          (out-assigned (odo:make-variable 'integer :name :out :min 1 :max 1))
          (r (odo:make-variable 'real :name :r :min 5d0 :max 5d0)))

      (odo:state-space-add! ss x)
      (is (odo:state-space-assigned-p ss))
      (odo:state-space-add! ss out-assigned)
      (is (odo:state-space-assigned-p ss))
      (odo:state-space-add! ss r)
      (is (odo:state-space-assigned-p ss))

      (is (odo:state-space-assigned-p ss))

      (odo:state-space-add! ss y2)
      (is (odo:state-space-assigned-p ss))
      (odo:state-space-add! ss y)
      (is (not (odo:state-space-assigned-p ss))))))
